searchData={"items":[{"type":"module","title":"Nebulex.Adapters.Ecto","doc":"Adapter backed by generic Ecto table.\nDesigned to be used as a highest level cache for data persistence.","ref":"Nebulex.Adapters.Ecto.html"},{"type":"function","title":"Nebulex.Adapters.Ecto.delete/3","doc":"","ref":"Nebulex.Adapters.Ecto.html#delete/3"},{"type":"function","title":"Nebulex.Adapters.Ecto.execute/4","doc":"","ref":"Nebulex.Adapters.Ecto.html#execute/4"},{"type":"function","title":"Nebulex.Adapters.Ecto.expire/3","doc":"","ref":"Nebulex.Adapters.Ecto.html#expire/3"},{"type":"function","title":"Nebulex.Adapters.Ecto.get/3","doc":"","ref":"Nebulex.Adapters.Ecto.html#get/3"},{"type":"function","title":"Nebulex.Adapters.Ecto.get_all/3","doc":"","ref":"Nebulex.Adapters.Ecto.html#get_all/3"},{"type":"function","title":"Nebulex.Adapters.Ecto.has_key?/2","doc":"","ref":"Nebulex.Adapters.Ecto.html#has_key?/2"},{"type":"function","title":"Nebulex.Adapters.Ecto.in_transaction?/1","doc":"","ref":"Nebulex.Adapters.Ecto.html#in_transaction?/1"},{"type":"function","title":"Nebulex.Adapters.Ecto.put/6","doc":"","ref":"Nebulex.Adapters.Ecto.html#put/6"},{"type":"function","title":"Nebulex.Adapters.Ecto.put_all/5","doc":"","ref":"Nebulex.Adapters.Ecto.html#put_all/5"},{"type":"function","title":"Nebulex.Adapters.Ecto.stream/3","doc":"","ref":"Nebulex.Adapters.Ecto.html#stream/3"},{"type":"function","title":"Nebulex.Adapters.Ecto.take/3","doc":"","ref":"Nebulex.Adapters.Ecto.html#take/3"},{"type":"function","title":"Nebulex.Adapters.Ecto.touch/2","doc":"","ref":"Nebulex.Adapters.Ecto.html#touch/2"},{"type":"function","title":"Nebulex.Adapters.Ecto.transaction/3","doc":"","ref":"Nebulex.Adapters.Ecto.html#transaction/3"},{"type":"function","title":"Nebulex.Adapters.Ecto.ttl/2","doc":"","ref":"Nebulex.Adapters.Ecto.html#ttl/2"},{"type":"function","title":"Nebulex.Adapters.Ecto.update_counter/6","doc":"","ref":"Nebulex.Adapters.Ecto.html#update_counter/6"},{"type":"extras","title":"Nebulex.Adapters.Ecto","doc":"# Nebulex.Adapters.Ecto\n\nExtremely simple Ecto Postgres adapter for Nebulex Cache library.\nDesigned to be used as the last level adapter inside multilevel cache.\n\nThis adapter implements:\n1. Basic key-value cache interface.\n2. Cache transactions.\n3. Basic queries without patterns.\n\nCache eviction strategy is LRW or LRU based on the last touched timestamp.","ref":"readme.html"},{"type":"extras","title":"Installation - Nebulex.Adapters.Ecto","doc":"In `mix.exs`:\n```elixir\ndefp deps do\n  [\n    {:nebulex_adapters_ecto, \"~> 1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Setup - Nebulex.Adapters.Ecto","doc":"#","ref":"readme.html#setup"},{"type":"extras","title":"Configuration - Nebulex.Adapters.Ecto","doc":"In your `runtime.exs`:\n```elixir\nconfig :my_app, MyApp.Cache,\n  # Available strategies are LRW and LRU\n  strategy: :lrw,\n\n  # Repository to be used to access table with cache\n  repo: MyApp.Repo,\n\n  # The table as a string (or Schema) which will hold cache data\n  table: \"cache_table\",\n\n  # Maximum amount of data present in the table (in rows)\n  max_amount: 1000,\n\n  # Timeout of garbage collection in milliseconds\n  gc_timeout: :timer.hours(2),\n\n  # The function to generate timestamps in milliseconds\n  timestamp_mfa: {:erlang, :system_time, [:millisecond]}\n```\n\n#","ref":"readme.html#configuration"},{"type":"extras","title":"Table - Nebulex.Adapters.Ecto","doc":"The most simple migration for cache table would look like this:\n\n```elixir\ndefmodule Nebulex.Adapters.EctoTest.Repo.Migrations.CreateCacheTable do\n  use Ecto.Migration\n\n  def change do\n    create table \"cache_table\" do\n      add :key, :binary, primary_key: true\n      add :value, :binary\n      add :touched_at, :bigint\n      add :ttl, :integer\n    end\n\n    create unique_index(\"cache_table\", :key)\n  end\nend\n```\n\nHowever, feel free to create your own indexes. For example, to speed up\ngarbage collection, I'd suggest using `touched_at + ttl` btree index.","ref":"readme.html#table"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"1.0.0 - Changelog","doc":"First usable version!","ref":"changelog.html#1-0-0"}],"content_type":"text/markdown"}